=== xbmc/addons/CMakeLists.txt ===
set(SOURCES Addon.cpp
            AddonBuilder.cpp
            BinaryAddonCache.cpp
            AddonDatabase.cpp
            AddonInstaller.cpp
            AddonManager.cpp
            AddonRepos.cpp
            AddonStatusHandler.cpp
            AddonSystemSettings.cpp
            AddonUpdateRules.cpp
            AddonVersion.cpp
            AudioDecoder.cpp
            ContextMenuAddon.cpp
            ContextMenus.cpp
            ExtsMimeSupportList.cpp
            FontResource.cpp
            FilesystemInstaller.cpp
            GameResource.cpp
            ImageDecoder.cpp
            ImageResource.cpp
            LanguageResource.cpp
            PluginSource.cpp
            Repository.cpp
            RepositoryUpdater.cpp
            Scraper.cpp
            ScreenSaver.cpp
            Service.cpp
            Skin.cpp
            UISoundsResource.cpp
            VFSEntry.cpp
            Visualization.cpp
            Webinterface.cpp)

set(HEADERS Addon.h
            AddonBuilder.h
            AddonEvents.h
            AddonRepoInfo.h
            BinaryAddonCache.h
            AddonDatabase.h
            AddonInstaller.h
            AddonManager.h
            AddonProvider.h
            AddonRepos.h
            AddonStatusHandler.h
            AddonSystemSettings.h
            AddonUpdateRules.h
            AddonVersion.h
            AudioDecoder.h
            ContextMenuAddon.h
            ContextMenus.h
            ExtsMimeSupportList.h
            FilesystemInstaller.h
            FontResource.h
            GameResource.h
            IAddon.h
            IAddonManagerCallback.h
            IAddonSupportCheck.h
            ImageDecoder.h
            ImageResource.h
            LanguageResource.h
            PluginSource.h
            Repository.h
            RepositoryUpdater.h
            Resource.h
            Scraper.h
            ScreenSaver.h
            Service.h
            Skin.h
            UISoundsResource.h
            VFSEntry.h
            Visualization.h
            Webinterface.h)

core_add_library(addons)
