=== xbmc/weather/CMakeLists.txt ===
set(SOURCES GUIWindowWeather.cpp
            WeatherJob.cpp
            WeatherManager.cpp)

set(HEADERS GUIWindowWeather.h
            WeatherJob.h
            WeatherManager.h)

core_add_library(weather)
