=== xbmc/media/drm/CMakeLists.txt ===
set(SOURCES CryptoSession.cpp)

set(HEADERS CryptoSession.h)

core_add_library(drm)
