=== debian/changelog ===
kodi (2:21.2+dfsg-4pureos1) dawn; urgency=medium

  * Sync with Debian trixie
  * Remaining PureOS changes:
    - suppress building official repository package;
      PureOS: #209

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Mon, 20 Oct 2025 08:56:08 +0200

kodi (2:20.1+dfsg-1pureos1) crimson; urgency=medium

  * Sync with Debian bookworm
  * Remaining PureOS changes:
    - suppress building official repository package;
      PureOS: #209

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Thu, 22 Jun 2023 11:20:50 +0200

kodi (2:19.1+dfsg2-2+deb11u1pureos1) byzantium; urgency=medium

  * Merge with Debian Bullseye, remaining change:
    - suppress building official repository package;
      PureOS: #209

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Wed, 07 Jun 2023 04:17:50 +0200

kodi (2:19.1+dfsg2-2+deb11u1) bullseye; urgency=medium

  * Branch out bullseye
  * Fix buffer overflow in PLS playlists (Closes: CVE-2021-42917)

 -- Vasyl Gello <vasek.gello@gmail.com>  Thu, 04 Nov 2021 09:17:25 +0000

kodi (2:19.0+dfsg1-1pureos1) byzantium; urgency=medium

  * fork for PureOS:
    + set PureOS Maintainers as maintainer,
      leaving original as XSBC-Original-Maintainer
    + drop uploaders (unused by PureOS Maintainers)
    + replace Vcs-* fields
    + add git-buildpackage setting debian-branch
  * suppress building official repository package;
    PureOS: #209

 -- Jonas Smedegaard <jonas.smedegaard@puri.sm>  Sat, 27 Mar 2021 13:26:29 +0100
